;;; <fuelle-schrittweise-erarbeitung-2012.scm

; globale Variable nur zur Vereinfachung
(define
  stuecke
  '(30 30 30 20 20 20 10 10 10))

;;; ----- 1 -----
(define
  (fuelle stuecke container zielgroesse)
  'undefiniert)

; Test:
(fuelle stuecke `() 80)

;;; ----- Hilfsfunktion exakt-voll? -----
; prüft, ob der container die Zielgröße erreicht hat.
(define
  (exakt-voll? container zielgroesse)
  (= (apply + container) zielgroesse)
  )

;;; ----- 2 -----
(define
  (fuelle stuecke container zielgroesse)
  (cond
    [(exakt-voll? container zielgroesse) container]
    [else
     'undefiniert]
    )
  )

; Test:
(fuelle stuecke `() 80)
(fuelle stuecke `(30 20) 80)

;;; ----- Hilfsfunktion zu-voll? -----
; prüft, ob das Stück noch in den container passt.
(define
  (zu-voll? stueck container zielgroesse)
  (> (+ stueck (apply + container)) zielgroesse))

;;; ----- 3 -----
; Container zu voll wird geprüft.
(define
  (fuelle stuecke container zielgroesse)
  (cond
    [(exakt-voll? container zielgroesse) container]
    [(zu-voll? (first stuecke) container zielgroesse)
     (fuelle (cdr stuecke) container zielgroesse)]               
    [else
     'undefiniert]
    )
  )

; Test:
(fuelle stuecke `(30 20) 80)
(fuelle '(40 20) `(30 30) 80)

;;; ----- 4 -----
; Der Container ist noch nicht voll genug.
; Die muss aber nicht erneut geprüft werden, da es die einzige Alternative ist.
(define
  (fuelle stuecke container zielgroesse)
  (cond
    [(exakt-voll? container zielgroesse) container]
    [(zu-voll? (first stuecke) container zielgroesse)
     (fuelle stuecke (cdr container) zielgroesse)]               
    [else
     (fuelle (rest stuecke) (cons (first stuecke) container) zielgroesse)]
    )
  )

; Test:
(fuelle stuecke `() 80)
(fuelle stuecke `(30 20) 80)
(fuelle stuecke `(30 30) 80)

;;; Was aber ist, wenn es nicht geht?
;;; Woran merken wir das?
;;; ----- 5 -----
; Die Stücke-Liste ist leer.
(define
  (fuelle stuecke container zielgroesse)
  (cond
    [(exakt-voll? container zielgroesse) container]
    [(null? stuecke) "Keine Lösung"]
    [(zu-voll? (first stuecke) container zielgroesse)
     (fuelle stuecke (cdr container) zielgroesse)]               
    [else
     (fuelle (rest stuecke) (cons (first stuecke) container) zielgroesse)]
    )
  )

; Test:
(fuelle stuecke `() 80)
(fuelle stuecke `(30 30 20) 80)
(fuelle stuecke `(30 30 30) 80)
(fuelle stuecke `(30 30 30) 95) ; Erwartung: Geht nicht!
